/**
      SoS (Sense Of Self) // Reading Sensor's data to Dweet // TeZ 2017
      //  http://dweet.io/
 */

#include <Arduino.h>
#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>
#include <ESP8266HTTPClient.h>
#define USE_SERIAL Serial

#include <NeoPixelBus.h>
const uint16_t PixelCount = 1; // how many neopixels in your strip?
const uint8_t PixelPin = 2; // ignored for Esp8266 - Wemos, it uses GPIO2 = PIN D4 (UART MODE)
#define colorSaturation 128
// UART MODE, HIGH SPEED
NeoPixelBus<NeoGrbFeature, NeoEsp8266Uart800KbpsMethod> strip(PixelCount, PixelPin);
int s_red = 0;
int s_green = 0;
int s_blue = 0;
int sindex = -1; 
String sg = "";

ESP8266WiFiMulti WiFiMulti;
HTTPClient myhttp;

String response;

float prog = 0;



///////////////////////////////////////////////////
void setup() {

    // this resets all the neopixels to an off state
    strip.Begin();
    strip.Show();

    s_green=200;
    response = "nada";


    USE_SERIAL.begin(115200);
   // USE_SERIAL.setDebugOutput(true);

    USE_SERIAL.println();
    USE_SERIAL.println();
    USE_SERIAL.println();

    for(uint8_t t = 4; t > 0; t--) {
        USE_SERIAL.printf("[SETUP] WAIT %d...\n", t);
        USE_SERIAL.flush();
        delay(1000);
    }

    delay(1000);

    // WiFiMulti.addAP("SSID", "PASSWORD");
    WiFiMulti.addAP("KABK-Guest", "");
 


 // wait for WiFi connection
     USE_SERIAL.print("Connecting to local WiFi ");
    while((WiFiMulti.run() != WL_CONNECTED)) {
        USE_SERIAL.print(".");
    }

    // dweeter.concat("X"); // test concat
  
    USE_SERIAL.println();
    USE_SERIAL.println("YEAH!!  Connected to local WiFi ");
    USE_SERIAL.println();

}




///////////////////////////////////////////////////
void GetDweet(String mysensor){

    //   posthttp.begin("http://dweet.io/get/latest/dweet/for/tez-sensor-02"); // here connects to GET DWEET data

          String sensorUrl = "http://dweet.io/get/latest/dweet/for/";
          sensorUrl.concat(mysensor);
       
          myhttp.begin(sensorUrl); // here connects to GET DWEET data
 
        // start connection and send HTTP header
        int httpCode = myhttp.GET();
 
        // httpCode will be negative on error
        if(httpCode > 0) {
            // HTTP header has been send and Server response header has been handled
           // USE_SERIAL.printf("[HTTP] GET... code: %d\n", httpCode);

            // file found at server
            if(httpCode == HTTP_CODE_OK) {
                String payload = myhttp.getString();
                response=payload;
                // USE_SERIAL.println(payload);
            }
        } else {
            USE_SERIAL.printf("[HTTP] GET... failed, error: %s\n", myhttp.errorToString(httpCode).c_str());
        }

       myhttp.end();

}




///////////////////////////////////////////////////
void loop() {
    

      // read channel
      GetDweet("sosneopix"); // here you can change "sosneopix" with your personal channel name 
      delay(1000);

      Serial.println(response);

      // read red from DWEET response
      sindex = response.indexOf("sos_red");
      Serial.print("sindex: ");
      Serial.println(sindex);
      
      if(sindex != -1){
       sg = response.substring(sindex + 9, sindex + 12);    
       Serial.print("sg: ");
       Serial.println(sg);   
       s_red = sg.toInt();
      }

     
      // read green from DWEET response
      sindex = response.indexOf("sos_green");
      Serial.print("sindex: ");
      Serial.println(sindex);
      
      if(sindex != -1){
       sg = response.substring(sindex + 11, sindex + 14);    
       Serial.print("sg: ");
       Serial.println(sg);   
       s_green = sg.toInt();
      }

       // read blue from DWEET response
      sindex = response.indexOf("sos_blue");
      Serial.print("sindex: ");
      Serial.println(sindex);
      
      if(sindex != -1){
       sg = response.substring(sindex + 10, sindex + 13);    
       Serial.print("sg: ");
       Serial.println(sg);   
       s_blue = sg.toInt();
      }
     

      // SET NEOPIXEL COLORS AND SHOW
      RgbColor sos_color(s_red, s_green, s_blue);
      strip.SetPixelColor(0,sos_color);
      strip.Show();
       

}

