/**
      SoS (Sense Of Self) // Sending and Reading Sensor's data to Dweet // TeZ 2017
      //  http://dweet.io/
 */

#include <Arduino.h>
#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>
#include <ESP8266HTTPClient.h>
#define USE_SERIAL Serial

#include <NeoPixelBus.h>
const uint16_t PixelCount = 1; // how many neopixels in your strip?
const uint8_t PixelPin = 2; // ignored for Esp8266 - Wemos, it uses GPIO2 = PIN D4 (UART MODE)
#define colorSaturation 128
// UART MODE, HIGH SPEED
NeoPixelBus<NeoGrbFeature, NeoEsp8266Uart800KbpsMethod> strip(PixelCount, PixelPin);
int s_red = 0;
int s_green = 0;
int s_blue = 0;
int sindex = -1; 
String sg = "";

ESP8266WiFiMulti WiFiMulti;
HTTPClient myhttp;

String mydweeter = "http://dweet.io/dweet/for/sosneopix?whatever="; // here you can change sosneopix with your personal channel name

String dweeter_red = "http://dweet.io/dweet/for/sosneopix?sos_red=";
String dweeter_green = "http://dweet.io/dweet/for/sosneopix?sos_green=";
String dweeter_blue = "http://dweet.io/dweet/for/sosneopix?sos_blue_b=";
String response;

float prog = 0;



///////////////////////////////////////////////////
void setup() {

    // this resets all the neopixels to an off state
    strip.Begin();
    strip.Show();

    s_green=200;
    response = "nada";


    USE_SERIAL.begin(115200);
   // USE_SERIAL.setDebugOutput(true);

    USE_SERIAL.println();
    USE_SERIAL.println();
    USE_SERIAL.println();

    for(uint8_t t = 4; t > 0; t--) {
        USE_SERIAL.printf("[SETUP] WAIT %d...\n", t);
        USE_SERIAL.flush();
        delay(1000);
    }

    delay(1000);

    // WiFiMulti.addAP("SSID", "PASSWORD");
    WiFiMulti.addAP("KABK-Guest", "");
 


 // wait for WiFi connection
     USE_SERIAL.print("Connecting to local WiFi ");
    while((WiFiMulti.run() != WL_CONNECTED)) {
        USE_SERIAL.print(".");
    }

    // dweeter.concat("X"); // test concat
  
    USE_SERIAL.println();
    USE_SERIAL.println("YEAH!!  Connected to local WiFi ");
    USE_SERIAL.println();

    delay (1000);
       PostDweet("sosneopix","sos_red",200); // first call to init the communication
    delay (2000);
}


///////////////////////////////////////////////////
  void PostDweet(String mychannel, String myparam, float myvalue){

        mydweeter = "http://dweet.io/dweet/for/";//
        mydweeter.concat(mychannel); // here you can change the channel with yours
        mydweeter.concat("?");
        mydweeter.concat(myparam); // here you can change the parameter with your variable
        mydweeter.concat("=");
        mydweeter.concat(myvalue); 
        myhttp.begin(mydweeter); // here connects and POSTs data to DWEET at the same time
        USE_SERIAL.print("POSTed >> "); 
        // USE_SERIAL.println(dweeter);


          // GET SESSION
        // start connection and send HTTP header
        int httpCode = myhttp.GET();
 
        // httpCode will be negative on error
        if(httpCode > 0) {
            // HTTP header has been send and Server response header has been handled
            USE_SERIAL.printf("[HTTP] GET... code: %d\n", httpCode);

            // file found at server
            if(httpCode == HTTP_CODE_OK) {
                String payload = myhttp.getString();
                USE_SERIAL.println(payload);
            }
        } else {
            USE_SERIAL.printf("[HTTP] GET... failed, error: %s\n", myhttp.errorToString(httpCode).c_str());
        }

         
        myhttp.end();


}



///////////////////////////////////////////////////
void loop() {
    
        int r = random(200);
        PostDweet("sosneopix","sos_red",r); // Use this to POST data from your sensor(s)
        delay(2000);

}

